//
//  Sample.h
//  SiiLibSample
//

#import <Foundation/Foundation.h>
#import "ViewController.h"
#import "SIIPrinterManager.h"

@interface Sample : NSObject

+ (void)InitialSetting:(ViewController *)view;
+ (BOOL)connectSample:(NSInteger)model address:(NSString *)address type:(NSInteger)type;
+ (BOOL)disconnectSample;
+ (BOOL)printPageModeSample;
+ (BOOL)sendTextSample:(NSString *)text;
+ (BOOL)sendTextExSample:(NSString *)text;
+ (BOOL)printBarcodeSample;
+ (BOOL)printPDF417Sample;
+ (BOOL)printQRcodeSample;
+ (BOOL)printDataMatrixSample;
+ (BOOL)printMaxiCodeSample;
+ (BOOL)printGS1DataBarStackedSample;
+ (BOOL)printGS1DataBarStackedOmnidirectionalSample;
+ (BOOL)printGS1DataBarExpandedStackedSample;
+ (BOOL)printAztecCodeSample;
+ (BOOL)cutPaperSample:(NSInteger)cuttingMethod;
+ (BOOL)feedPositionSample;
+ (BOOL)openDrawerSample;
+ (BOOL)buzzerSample;
+ (BOOL)externalBuzzerSample;
+ (BOOL)sendBinarySample:(NSData *)data;
+ (BOOL)sendDataFileSample:(NSString *)filePath;
+ (BOOL)getStatusSample;
+ (BOOL)abortSample;
+ (BOOL)registerLogoSample:(NSString *)filePath;
+ (BOOL)printLogoSample;
+ (BOOL)unregisterLogoSample;
+ (BOOL)registerStyleSheetSample:(NSString *)filePath;
+ (BOOL)unregisterStyleSheetSample;
+ (BOOL)resetPrinterSample;
+ (BOOL)getPrinterResponseSample:(NSInteger)responseId;
+ (void)startLanDiscoveryPrinterSample:(NSInteger)retryCount timeout:(NSInteger)timeout;
+ (BOOL)getPrinterDiscoveryCompletion;
+ (void)startBluetoothDiscoveryPrinterSample;
+ (void)cancelDiscoveryPrinterSample;
+ (NSArray *)getFoundPrinterSample;
+ (BOOL)getVersionSample;
+ (BOOL)controlTransactionSample:(NSInteger)transactionFunction;
+ (NSInteger)get_sendTimeoutSample;
+ (void)set_sendTimeoutSample:(NSInteger)time;
+ (NSInteger)get_receiveTimeoutSample;
+ (void)set_receiveTimeoutSample:(NSInteger)time;
+ (void)get_internationalCharacterSample;
+ (void)set_internationalCharacterSample:(NSInteger)internationalCharacter;
+ (void)get_codePageSample;
+ (void)set_codePageSample:(NSInteger)codePage;
+ (void)get_printerModelSample;
+ (void)get_portTypeSample;
+ (void)get_isConnectSample;
+ (NSInteger)get_socketKeepingTimeSample;
+ (void)set_socketKeepingTimeSample:(NSInteger)time;
+ (BOOL)defragmentSample;
+ (BOOL)initializeMemoryAreaSample;
+ (BOOL)showTemplateSample:(NSInteger)time_ms;
+ (BOOL)showSlideSample:(NSInteger)slideID time_ms:(NSInteger)time_ms;
+ (BOOL)enterStandbyModeSample;
+ (BOOL)executeMacroSample:(NSInteger)macroID repeatCount:(NSInteger)repeatCount;
+ (BOOL)turnOnScreenSample:(BOOL)isOn;
+ (BOOL)selectTemplateSample:(NSInteger)templateID slideID:(NSInteger)slideID;
+ (BOOL)setTemplateImageDataSample:(NSInteger)mapID imageID:(NSInteger)imageID;
+ (BOOL)selectTemplateTextObjectSample:(NSInteger)mapID;
+ (BOOL)setTemplateTextAlignmentSample:(NSInteger)alignment;
+ (BOOL)setTemplateTextLeftMarginSample:(NSInteger)margin;
+ (BOOL)setTemplateTextLineSpacingSample:(NSInteger)spacing;
+ (BOOL)setTemplateTextBoldSample:(NSInteger)bold;
+ (BOOL)setTemplateTextUnderlineSample:(NSInteger)underline;
+ (BOOL)setTemplateTextSizeSample:(NSInteger)scale;
+ (BOOL)setTemplateTextFontSample:(NSInteger)font;
+ (BOOL)setTemplateTextRegisteredFontSample:(NSInteger)font;
+ (BOOL)setTemplateTextRightSpacingSample:(NSInteger)spacing;
+ (BOOL)setTemplateTextColorSample:(NSInteger)color;
+ (BOOL)setTemplateTextDataSample:(NSString *)text;
+ (BOOL)setTemplateBarcodeDataSample:(NSInteger)mapID text:(NSString *)text;
+ (BOOL)setTemplateQrCodeDataSample:(NSInteger)mapID text:(NSString *)text;
+ (BOOL)registerTemplateSample:(NSInteger)templateID label:(NSString *)label fileName:(NSString *)fileName;
+ (BOOL)unregisterTemplateSample:(NSInteger)templateID;
+ (BOOL)registerImageDataSample:(NSInteger)imageID label:(NSString *)label fileName:(NSString *)fileName;
+ (BOOL)unregisterImageDataSample:(NSInteger)imageID;
+ (BOOL)registerSlideDataSample:(NSInteger)slideID label:(NSString *)label fileName:(NSString *)fileName;
+ (BOOL)unregisterSlideDataSample:(NSInteger)slideID;
+ (BOOL)registerUserDefinedCharacterSample:(NSString *)fileName;
+ (BOOL)unregisterUserDefinedCharacterSample;
+ (BOOL)registerOptionFontSample:(NSInteger)startCode endCode:(NSInteger)endCode width:(NSInteger)width height:(NSInteger)height fileName:(NSString *)fileName;
+ (BOOL)unregisterOptionFontSample;
+ (BOOL)controlMacroRegistrationSample:(NSInteger)macroID control:(NSInteger)control;
+ (BOOL)getDisplayResponseSample:(NSInteger)responseId;
+ (BOOL)getDisplayResponseSample:(NSInteger)responseId paramId:(NSInteger)paramId;
+ (BOOL)selectSmartLabelFileSample:(NSString *)filePath;
+ (BOOL)replaceSmartLabelTextDataSample:(NSInteger)mapID text:(NSString *)text;
+ (BOOL)replaceSmartLabelBarcodeDataSample:(NSInteger)mapID text:(NSString *)text;
+ (BOOL)replaceSmartLabelImageDataSample:(NSInteger)mapID image:(UIImage *)image;
+ (BOOL)printSmartLabelImageDataSample;

+ (NSString *)getResultMessage;

@end

