//
//  ViewController.h
//  SiiLibSample
//

#import <UIKit/UIKit.h>
#import "SIIPrinterManager.h"

@interface ViewController : UIViewController <SIIPrinterManagerDelegate>
{
    IBOutlet UITextField *_addressTxt;
    IBOutlet UITextField *_printerModel;
    IBOutlet UISegmentedControl *_printerTypeSeg;
    IBOutlet UITextField *_lastStatus;
    IBOutlet UIScrollView *_scrollView;
    IBOutlet UITextField *_barcodeStatus;
    IBOutlet UITextView *_barcodeData;
    IBOutlet UISwitch *_barcodeEncodeSwitch;
    IBOutlet UILabel *_barcodeEncodeSwicthLabel;
}

- (IBAction)onPrinterTypeSegClicked:(id)sender;
- (IBAction)onSelectPrinterModelButtonClicked:(id)sender;
- (IBAction)onSerchButtonClicked:(id)sender;
- (IBAction)onConnectButtonClicked:(id)sender;
- (IBAction)onDisconnectButtonClicked:(id)sender;
- (IBAction)onPrintPageModeSampleButtonClicked:(id)sender;
- (IBAction)onSendTextButtonClicked:(id)sender;
- (IBAction)onSendTextExButtonClicked:(id)sender;
- (IBAction)onPrintBarcodeButtonClicked:(id)sender;
- (IBAction)onPrintPDF417ButtonClicked:(id)sender;
- (IBAction)onPrintQRcodeButtonClicked:(id)sender;
- (IBAction)onPrintDataMatrixButtonClicked:(id)sender;
- (IBAction)onPrintMaxiCodeButtonClicked:(id)sender;
- (IBAction)onPrintGS1DataBarStackedButtonClicked:(id)sender;
- (IBAction)onPrintGS1DataBarStackedOmnidirectionalButtonClicked:(id)sender;
- (IBAction)onPrintGS1DataBarExpandedStackedButtonClicked:(id)sender;
- (IBAction)onPrintAztecCodeButtonClicked:(id)sender;
- (IBAction)onCutPaperButtonClicked:(id)sender;
- (IBAction)onFeedPositionButtonClicked:(id)sender;
- (IBAction)onOpenDrawerButtonClicked:(id)sender;
- (IBAction)onBuzzerButtonClicked:(id)sender;
- (IBAction)onExternalBuzzerButtonClicked:(id)sender;
- (IBAction)onSendBinaryButtonClicked:(id)sender;
- (IBAction)onSendDataFileButtonClicked:(id)sender;
- (IBAction)onGetStatusButtonClicked:(id)sender;
- (IBAction)onAbortButtonClicked:(id)sender;
- (IBAction)onRegisterLogoButtonClicked:(id)sender;
- (IBAction)onPrintLogoButtonClicked:(id)sender;
- (IBAction)onUnregisterLogoButtonClicked:(id)sender;
- (IBAction)onRegisterStyleSheetButtonClicked:(id)sender;
- (IBAction)onUnregisterStyleSheetButtonClicked:(id)sender;
- (IBAction)onResetPrinterButtonClicked:(id)sender;
- (IBAction)onGetPrinterResponseButtonClicked:(id)sender;
- (IBAction)onStartDiscoveryPrinterButtonClicked:(id)sender;
- (IBAction)onCancelDiscoveryPrinterButtonClicked:(id)sender;
- (IBAction)onGetFoundPrinterButtonClicked:(id)sender;
- (IBAction)onGetVersionButtonOnClicked:(id)sender;
- (IBAction)onControlTransactionButtonClicked:(id)sender;
- (IBAction)onSendTimeoutButtonClicked:(id)sender;
- (IBAction)onReceiveTimeoutButtonClicked:(id)sender;
- (IBAction)onInternationalCharacterButtonClicked:(id)sender;
- (IBAction)onCodePageButtonClicked:(id)sender;
- (IBAction)onPrinterModelButtonClicked:(id)sender;
- (IBAction)onPortTypeButtonClicked:(id)sender;
- (IBAction)onIsConnectButtonClicked:(id)sender;
- (IBAction)onSocketKeepingTimeButtonClicked:(id)sender;
- (IBAction)onDefragmentButtonClicked:(id)sender;
- (IBAction)onShowTemplateButtonClicked:(id)sender;
- (IBAction)onShowSlideButtonClicked:(id)sender;
- (IBAction)onEnterStandByButtonClicked:(id)sender;
- (IBAction)onExecuteMacroButtonClicked:(id)sender;
- (IBAction)onTurnOnScreenButtonClicked:(id)sender;
- (IBAction)onSelectTemplateButtonClicked:(id)sender;
- (IBAction)onSetTemplateImageDataButtonClicked:(id)sender;
- (IBAction)onSelectTemplateTextObjectButtonClicked:(id)sender;
- (IBAction)onSetTemplateTextAlignmentButtonClicked:(id)sender;
- (IBAction)onSetTemplateTextLeftMarginButtonClicked:(id)sender;
- (IBAction)onSetTemplateTextLineSpacingButtonClicked:(id)sender;
- (IBAction)onSetTemplateTextBoldButtonClicked:(id)sender;
- (IBAction)onSetTemplateTextUnderlineButtonClicked:(id)sender;
- (IBAction)onSetTemplateTextSizeButtonClicked:(id)sender;
- (IBAction)onSetTemplateTextFontButtonClicked:(id)sender;
- (IBAction)onSetTemplateTextRegisteredFontButtonClicked:(id)sender;
- (IBAction)onSetTemplateTextRightSpacingButtonClicked:(id)sender;
- (IBAction)onSetTemplateTextColorButtonClicked:(id)sender;
- (IBAction)onSetTemplateTextDataButtonClicked:(id)sender;
- (IBAction)onSetTemplateBarcodeDataButtonClicked:(id)sender;
- (IBAction)onSetTemplateQrCodeDataButtonClicked:(id)sender;
- (IBAction)onRegisterTemplateButtonClicked:(id)sender;
- (IBAction)onUnregisterTemplateButtonClicked:(id)sender;
- (IBAction)onRegisterImageDataButtonClicked:(id)sender;
- (IBAction)onUnregisterImageDataButtonClicked:(id)sender;
- (IBAction)onRegisterSlideDataButtonClicked:(id)sender;
- (IBAction)onUnregisterSlideDataButtonClicked:(id)sender;
- (IBAction)onRegisterUserDefinedCharacterButtonClicked:(id)sender;
- (IBAction)onUnregisterUserDefinedCharacterButtonClicked:(id)sender;
- (IBAction)onRegisterOptionFontButtonClicked:(id)sender;
- (IBAction)onUnregisterOptionFontButtonClicked:(id)sender;
- (IBAction)onControlMacroRegistrationButtonClicked:(id)sender;
- (IBAction)onGetDisplayResponseButtonClicked:(id)sender;
- (IBAction)onSelectSmartLabelFileButtonClicked:(id)sender;
- (IBAction)onReplaceTextDataButtonClicked:(id)sender;
- (IBAction)onReplaceBarcodeDataButtonOnClicked:(id)sender;
- (IBAction)onReplaceImageDataButtonOnClicked:(id)sender;
- (IBAction)onPrintSmartLabelImageDataButtonOnClicked:(id)sender;

@property (weak, nonatomic) IBOutlet UIButton *connectButton;
@property (weak, nonatomic) IBOutlet UIButton *disConnectButton;
@property (weak, nonatomic) IBOutlet UIButton *printPageModeButton;
@property (weak, nonatomic) IBOutlet UIButton *sendTextButton;
@property (weak, nonatomic) IBOutlet UIButton *sendTextExButton;
@property (weak, nonatomic) IBOutlet UIButton *printBarcodeButton;
@property (weak, nonatomic) IBOutlet UIButton *printPDF417Button;
@property (weak, nonatomic) IBOutlet UIButton *printQRcodeButton;
@property (weak, nonatomic) IBOutlet UIButton *printDataMatrixButton;
@property (weak, nonatomic) IBOutlet UIButton *printMaxiCodeButton;
@property (weak, nonatomic) IBOutlet UIButton *printGS1DataBarStackedButton;
@property (weak, nonatomic) IBOutlet UIButton *printGS1DataBarStackedOmnidirectionalButton;
@property (weak, nonatomic) IBOutlet UIButton *printGS1DataBarExpandedStackedButton;
@property (weak, nonatomic) IBOutlet UIButton *printAztecCodeButton;
@property (weak, nonatomic) IBOutlet UIButton *cutPaperButton;
@property (weak, nonatomic) IBOutlet UIButton *feedPositionButton;
@property (weak, nonatomic) IBOutlet UIButton *openDrawerButton;
@property (weak, nonatomic) IBOutlet UIButton *buzzerButton;
@property (weak, nonatomic) IBOutlet UIButton *externalBuzzerButton;
@property (weak, nonatomic) IBOutlet UIButton *sendBinaryButton;
@property (weak, nonatomic) IBOutlet UIButton *sendDataFileButton;
@property (weak, nonatomic) IBOutlet UIButton *getStatusButton;
@property (weak, nonatomic) IBOutlet UIButton *abortButton;
@property (weak, nonatomic) IBOutlet UIButton *registerLogoButton;
@property (weak, nonatomic) IBOutlet UIButton *printLogoButton;
@property (weak, nonatomic) IBOutlet UIButton *unregisterLogoButton;
@property (weak, nonatomic) IBOutlet UIButton *registerStyleSheetButton;
@property (weak, nonatomic) IBOutlet UIButton *unregisterStyleSheetButton;
@property (weak, nonatomic) IBOutlet UIButton *resetPrinterButton;
@property (weak, nonatomic) IBOutlet UIButton *getPrinterResponseButton;
@property (weak, nonatomic) IBOutlet UIButton *startDiscoveryPrinterButton;
@property (weak, nonatomic) IBOutlet UIButton *cancelDiscoveryPrinterButton;
@property (weak, nonatomic) IBOutlet UIButton *getFoundPrinterButton;
@property (weak, nonatomic) IBOutlet UIButton *getVersionButton;
@property (weak, nonatomic) IBOutlet UIButton *controlTransactionButton;
@property (weak, nonatomic) IBOutlet UIButton *sendTimeoutButton;
@property (weak, nonatomic) IBOutlet UIButton *receiveTimeoutButton;
@property (weak, nonatomic) IBOutlet UIButton *internationalCharacterButton;
@property (weak, nonatomic) IBOutlet UIButton *codePageButton;
@property (weak, nonatomic) IBOutlet UIButton *printerModelButton;
@property (weak, nonatomic) IBOutlet UIButton *portTypeButton;
@property (weak, nonatomic) IBOutlet UIButton *isConnectButton;
@property (weak, nonatomic) IBOutlet UIButton *socketKeepingTimeButton;
@property (weak, nonatomic) IBOutlet UIButton *defragmentButton;
@property (weak, nonatomic) IBOutlet UIButton *showTemplateButton;
@property (weak, nonatomic) IBOutlet UIButton *showSlideButton;
@property (weak, nonatomic) IBOutlet UIButton *enterStandbyModeButton;
@property (weak, nonatomic) IBOutlet UIButton *executeMacroButton;
@property (weak, nonatomic) IBOutlet UIButton *turnOnScreenButton;
@property (weak, nonatomic) IBOutlet UIButton *selectTemplateButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateImageDataButton;
@property (weak, nonatomic) IBOutlet UIButton *selectTemplateTextObjectButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateTextAlignmentButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateTextLeftMarginButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateTextLineSpacingButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateTextBoldButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateTextUnderlineButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateTextSizeButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateTextFontButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateTextRegisteredFontButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateTextRightSpacingButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateTextColorButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateTextDataButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateBarcodeDataButton;
@property (weak, nonatomic) IBOutlet UIButton *setTemplateQrCodeDataButton;
@property (weak, nonatomic) IBOutlet UIButton *registerTemplateButton;
@property (weak, nonatomic) IBOutlet UIButton *unregisterTemplateButton;
@property (weak, nonatomic) IBOutlet UIButton *registerImageDataButton;
@property (weak, nonatomic) IBOutlet UIButton *unregisterImageDataButton;
@property (weak, nonatomic) IBOutlet UIButton *registerSlideDataButton;
@property (weak, nonatomic) IBOutlet UIButton *unregisterSlideDataButton;
@property (weak, nonatomic) IBOutlet UIButton *registerUserDefinedCharacterButton;
@property (weak, nonatomic) IBOutlet UIButton *unregisterUserDefinedCharacterButton;
@property (weak, nonatomic) IBOutlet UIButton *registerOptionFontButton;
@property (weak, nonatomic) IBOutlet UIButton *unregisterOptionFontButton;
@property (weak, nonatomic) IBOutlet UIButton *controlMacroRegistrationButton;
@property (weak, nonatomic) IBOutlet UIButton *getDisplayResponseButton;
@property (weak, nonatomic) IBOutlet UIButton *selectSmartLabelFileButton;
@property (weak, nonatomic) IBOutlet UIButton *replaceTextDataButton;
@property (weak, nonatomic) IBOutlet UIButton *replaceBarcodeDataButton;
@property (weak, nonatomic) IBOutlet UIButton *replaceImageDataButton;
@property (weak, nonatomic) IBOutlet UIButton *printSmartLabelImageDataButton;

@end

