//
//  ViewController.swift
//  SiiLibSample
//

import UIKit

class ViewController: UIViewController , SIIPrinterManagerDelegate {
    fileprivate let KEY_TYPE_INTERFACE = "TYPE_INTERFACE"
    fileprivate let KEY_IP_PRINTER_MODEL = "IP_PRINTER_MODEL"
    fileprivate let KEY_BLUETOOTH_PRINTER_MODEL = "BLUETOOTH_PRINTER_MODEL"
    fileprivate let KEY_USB_PRINTER_MODEL = "KEY_USB_PRINTER_MODEL"
    fileprivate let KEY_IP_ADDRESS = "IP_ADDRESS"
    fileprivate let KEY_BLUETOOTH_ADDRESS = "BLUETOOTH_ADDRESS"
    fileprivate let KEY_USB_ADDRESS = "KEY_USB_ADDRESS"
    fileprivate let TEXT_FIELD_TYPE_TCP = "TCP"
    fileprivate let TEXT_FIELD_TYPE_BLUETOOTH = "BLUETOOTH"
    fileprivate let TEXT_FIELD_TYPE_USB = "USB"
    fileprivate let TEXT_FIELD_DEFAULT_MODEL = "not selected"
    fileprivate let TEXT_FIELD_DEFAULT_ADDRESS = "not selected"
    fileprivate let SII_EXTERNAL_ACCESSORY_PROTOCOL = "com.sii-ps.siieap"
    fileprivate let SEGMENT_TCP_IP = 0
    fileprivate let SEGMENT_BLUETOOTH = 1
    fileprivate let SEGMENT_USB = 2
    fileprivate let DOCUMENTS_PATH = NSSearchPathForDirectoriesInDomains(.documentDirectory, .allDomainsMask, true).first!

    @objc
    internal var _addressTxt: UITextField!
    @objc
    internal var _printerModel: UITextField!
    @objc
    internal var _printerTypeSeg: UISegmentedControl!
    @objc
    internal var _lastStatus: UITextField!
    @objc
    internal var _scrollView: UIScrollView!

    @IBOutlet weak var _barcodeStatus: UITextField!
    @IBOutlet weak var _barcodeData: UITextView!
    @IBOutlet weak var _barcodeEncodeSwitch: UISwitch!
    @IBOutlet weak var _barcodeEncodeSwicthLabel: UILabel!

    fileprivate var _loadingViewBackGraund: UIView!
    fileprivate var _loadingViewFrame: UIView!
    fileprivate var _loadingIndicator: UIActivityIndicatorView!
    fileprivate var _loadingViewCancelButton: UIButton!

    fileprivate let _buttonTappQueue = DispatchQueue(label: "com.sii-ps.button")

    @IBOutlet fileprivate weak var connectButton: UIButton!
    @IBOutlet fileprivate weak var disConnectButton: UIButton!
    @IBOutlet fileprivate weak var printPageModeButton: UIButton!
    @IBOutlet fileprivate weak var sendTextButton: UIButton!
    @IBOutlet fileprivate weak var sendTextExButton: UIButton!
    @IBOutlet fileprivate weak var printBarcodeButton: UIButton!
    @IBOutlet fileprivate weak var printPDF417Button: UIButton!
    @IBOutlet fileprivate weak var printQRcodeButton: UIButton!
    @IBOutlet fileprivate weak var printDataMatrixButton: UIButton!
    @IBOutlet fileprivate weak var printMaxiCodeButton: UIButton!
    @IBOutlet fileprivate weak var printGS1DataBarStackedButton: UIButton!
    @IBOutlet fileprivate weak var printGS1DataBarStackedOmnidirectionalButton: UIButton!
    @IBOutlet fileprivate weak var printGS1DataBarExpandedStackedButton: UIButton!
    @IBOutlet fileprivate weak var printAztecCodeButton: UIButton!
    @IBOutlet fileprivate weak var cutPaperButton: UIButton!
    @IBOutlet fileprivate weak var feedPositionButton: UIButton!
    @IBOutlet fileprivate weak var openDrawerButton: UIButton!
    @IBOutlet fileprivate weak var buzzerButton: UIButton!
    @IBOutlet fileprivate weak var externalBuzzerButton: UIButton!
    @IBOutlet fileprivate weak var sendBinaryButton: UIButton!
    @IBOutlet fileprivate weak var sendDataFileButton: UIButton!
    @IBOutlet fileprivate weak var getStatusButton: UIButton!
    @IBOutlet fileprivate weak var abortButton: UIButton!
    @IBOutlet fileprivate weak var registerLogoButton: UIButton!
    @IBOutlet fileprivate weak var printLogoButton: UIButton!
    @IBOutlet fileprivate weak var unregisterLogoButton: UIButton!
    @IBOutlet fileprivate weak var registerStyleSheetButton: UIButton!
    @IBOutlet fileprivate weak var unregisterStyleSheetButton: UIButton!
    @IBOutlet fileprivate weak var resetPrinterButton: UIButton!
    @IBOutlet fileprivate weak var getPrinterResponseButton: UIButton!
    @IBOutlet fileprivate weak var startDiscoveryPrinterButton: UIButton!
    @IBOutlet fileprivate weak var cancelDiscoveryPrinterButton: UIButton!
    @IBOutlet fileprivate weak var getFoundPrinterButton: UIButton!
    @IBOutlet fileprivate weak var getVersionButton: UIButton!
    @IBOutlet fileprivate weak var controlTransactionButton: UIButton!
    @IBOutlet fileprivate weak var sendTimeoutButton: UIButton!
    @IBOutlet fileprivate weak var receiveTimeoutButton: UIButton!
    @IBOutlet fileprivate weak var internationalCharacterButton: UIButton!
    @IBOutlet fileprivate weak var codePageButton: UIButton!
    @IBOutlet fileprivate weak var printerModelButton: UIButton!
    @IBOutlet fileprivate weak var portTypeButton: UIButton!
    @IBOutlet fileprivate weak var isConnectButton: UIButton!
    @IBOutlet fileprivate weak var socketKeepingTimeButton: UIButton!
    @IBOutlet fileprivate weak var defragmentButton: UIButton!
    @IBOutlet fileprivate weak var showTemplateButton: UIButton!
    @IBOutlet fileprivate weak var showSlideButton: UIButton!
    @IBOutlet fileprivate weak var enterStandbyModeButton: UIButton!
    @IBOutlet fileprivate weak var executeMacroButton: UIButton!
    @IBOutlet fileprivate weak var turnOnScreenButton: UIButton!
    @IBOutlet fileprivate weak var selectTemplateButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateImageDataButton: UIButton!
    @IBOutlet fileprivate weak var selectTemplateTextObjectButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateTextAlignmentButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateTextLeftMarginButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateTextLineSpacingButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateTextBoldButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateTextUnderlineButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateTextSizeButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateTextFontButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateTextRegisteredFontButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateTextRightSpacingButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateTextColorButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateTextDataButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateBarcodeDataButton: UIButton!
    @IBOutlet fileprivate weak var setTemplateQrCodeDataButton: UIButton!
    @IBOutlet fileprivate weak var registerTemplateButton: UIButton!
    @IBOutlet fileprivate weak var unregisterTemplateButton: UIButton!
    @IBOutlet fileprivate weak var registerImageDataButton: UIButton!
    @IBOutlet fileprivate weak var unregisterImageDataButton: UIButton!
    @IBOutlet fileprivate weak var registerSlideDataButton: UIButton!
    @IBOutlet fileprivate weak var unregisterSlideDataButton: UIButton!
    @IBOutlet fileprivate weak var registerUserDefinedCharacterButton: UIButton!
    @IBOutlet fileprivate weak var unregisterUserDefinedCharacterButton: UIButton!
    @IBOutlet fileprivate weak var registerOptionFontButton: UIButton!
    @IBOutlet fileprivate weak var unregisterOptionFontButton: UIButton!
    @IBOutlet fileprivate weak var controlMacroRegistrationButton: UIButton!
    @IBOutlet fileprivate weak var getDisplayResponseButton: UIButton!
    @IBOutlet fileprivate weak var selectSmartLabelFileButton: UIButton!
    @IBOutlet fileprivate weak var replaceTextDataButton: UIButton!
    @IBOutlet fileprivate weak var replaceBarcodeDataButton: UIButton!
    @IBOutlet fileprivate weak var replaceImageDataButton: UIButton!
    @IBOutlet fileprivate weak var printSmartLabelImageDataButton: UIButton!

    // MARK: - View life cycle
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        Sample.InitialSetting(view: self)
        self.configureUIButtons()
        self.configureLoadingView()
        self.configureUITextField()
    }

    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        //
        let myDefaults = UserDefaults.standard
        if myDefaults.string(forKey: KEY_TYPE_INTERFACE) == (TEXT_FIELD_TYPE_TCP) {
            self._printerTypeSeg.selectedSegmentIndex = SEGMENT_TCP_IP
            self._printerModel.text = myDefaults.string(forKey: KEY_IP_PRINTER_MODEL)
            self._addressTxt.text = myDefaults.string(forKey: KEY_IP_ADDRESS)
        } else if myDefaults.string(forKey: KEY_TYPE_INTERFACE) == (TEXT_FIELD_TYPE_USB) {
            self._printerTypeSeg.selectedSegmentIndex = SEGMENT_USB
            self._printerModel.text = myDefaults.string(forKey: KEY_USB_PRINTER_MODEL)
            self._addressTxt?.text = myDefaults.string(forKey: KEY_USB_ADDRESS)
        } else {
            self.saveDefault(TEXT_FIELD_TYPE_BLUETOOTH as AnyObject, KEY_TYPE_INTERFACE)
            self._printerTypeSeg.selectedSegmentIndex = SEGMENT_BLUETOOTH
            self._printerModel.text = myDefaults.string(forKey: KEY_BLUETOOTH_PRINTER_MODEL)
            self._addressTxt?.text = myDefaults.string(forKey: KEY_BLUETOOTH_ADDRESS)
        }
    }

    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
        //
        self._scrollView.contentSize = CGSize(width: 288, height: 3612)
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    override func viewWillTransition(to size: CGSize, with coordinator: UIViewControllerTransitionCoordinator) {
        super.viewWillTransition(to: size, with: coordinator)
        //
        coordinator.animate(alongsideTransition: { (context: UIViewControllerTransitionCoordinatorContext) in
            self._loadingViewBackGraund.frame = self.view.bounds
            self._loadingViewFrame.layer.position = CGPoint(x: self.view.bounds.midX, y: self.view.bounds.midY)
            self._loadingViewCancelButton.layer.position = CGPoint(x: self._loadingViewFrame.bounds.midX, y: 95.0)
        }, completion: nil)
    }

    // MARK: - Button Action
    @IBAction func onPrinterTypeSegClicked(_ sender: UIButton) {
        if self._printerTypeSeg.selectedSegmentIndex == SEGMENT_TCP_IP {
            self.saveDefault(TEXT_FIELD_TYPE_TCP as AnyObject, KEY_TYPE_INTERFACE)
            self._addressTxt.text = UserDefaults.standard.string(forKey: KEY_IP_ADDRESS)
            self._printerModel.text = UserDefaults.standard.string(forKey: KEY_IP_PRINTER_MODEL)
        } else if self._printerTypeSeg.selectedSegmentIndex == SEGMENT_BLUETOOTH {
            self.saveDefault(TEXT_FIELD_TYPE_BLUETOOTH as AnyObject, KEY_TYPE_INTERFACE)
            self._addressTxt.text = UserDefaults.standard.string(forKey: KEY_BLUETOOTH_ADDRESS)
            self._printerModel.text = UserDefaults.standard.string(forKey: KEY_BLUETOOTH_PRINTER_MODEL)
        } else if self._printerTypeSeg.selectedSegmentIndex == SEGMENT_USB {
            self.saveDefault(TEXT_FIELD_TYPE_USB as AnyObject, KEY_TYPE_INTERFACE)
            self._addressTxt.text = UserDefaults.standard.string(forKey: KEY_USB_ADDRESS)
            self._printerModel.text = UserDefaults.standard.string(forKey: KEY_USB_PRINTER_MODEL)
        }
    }

    @IBAction func onSelectPrinterModelButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "", message: "Select printer model", preferredStyle: .alert)
        let modelList = ["DPU-S245", "DPU-S445", "MP-B20", "MP-B30", "MP-B30L", "RP-D10", "RP-E10", "RP-F10", "SLP720RT"]
        for modelName in modelList {
            alertController.addAction(
                UIAlertAction(title: modelName, style: .default, handler: { (action: UIAlertAction!) in 
                    // Don't use SIIPrinterManager methods in UIAlertAction
                    self._printerModel.text = modelName
                    if self._printerTypeSeg.selectedSegmentIndex == self.SEGMENT_TCP_IP {
                        if modelName == "DPU-S245" || modelName == "DPU-S445" || modelName == "MP-B20" {
                            self._printerTypeSeg.selectedSegmentIndex = self.SEGMENT_BLUETOOTH
                            self.saveDefault(self.TEXT_FIELD_TYPE_BLUETOOTH as AnyObject, self.KEY_TYPE_INTERFACE)
                            self.saveDefault(self._printerModel.text! as AnyObject, self.KEY_BLUETOOTH_PRINTER_MODEL)
                            self._addressTxt.text = UserDefaults.standard.string(forKey: self.KEY_BLUETOOTH_ADDRESS)
                        } else {
                            self.saveDefault(self._printerModel.text! as AnyObject, self.KEY_IP_PRINTER_MODEL)
                        }
                    } else if self._printerTypeSeg.selectedSegmentIndex == self.SEGMENT_BLUETOOTH {
                        if modelName == "SLP720RT" {
                            self._printerTypeSeg.selectedSegmentIndex = self.SEGMENT_TCP_IP
                            self.saveDefault(self.TEXT_FIELD_TYPE_TCP as AnyObject, self.KEY_TYPE_INTERFACE)
                            self.saveDefault(self._printerModel.text! as AnyObject, self.KEY_IP_PRINTER_MODEL)
                            self._addressTxt.text = UserDefaults.standard.string(forKey: self.KEY_IP_ADDRESS)
                        } else {
                            self.saveDefault(self._printerModel.text! as AnyObject, self.KEY_BLUETOOTH_PRINTER_MODEL)
                        }
                    } else if self._printerTypeSeg.selectedSegmentIndex == self.SEGMENT_USB {
                        if modelName == "RP-F10" {
                            self.saveDefault(self._printerModel.text! as AnyObject, self.KEY_USB_PRINTER_MODEL)
                        } else if modelName == "SLP720RT" {
                            self._printerTypeSeg.selectedSegmentIndex = self.SEGMENT_TCP_IP
                            self.saveDefault(self.TEXT_FIELD_TYPE_TCP as AnyObject, self.KEY_TYPE_INTERFACE)
                            self.saveDefault(self._printerModel.text! as AnyObject, self.KEY_IP_PRINTER_MODEL)
                            self._addressTxt.text = UserDefaults.standard.string(forKey: self.KEY_IP_ADDRESS)
                        } else {
                            self._printerTypeSeg.selectedSegmentIndex = self.SEGMENT_BLUETOOTH
                            self.saveDefault(self.TEXT_FIELD_TYPE_BLUETOOTH as AnyObject, self.KEY_TYPE_INTERFACE)
                            self.saveDefault(self._printerModel.text! as AnyObject, self.KEY_BLUETOOTH_PRINTER_MODEL)
                            self._addressTxt.text = UserDefaults.standard.string(forKey: self.KEY_BLUETOOTH_ADDRESS)
                        }
                    }
                })
            )
        }
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSerchButtonClicked(_ sender: UIButton) {
        if self._printerTypeSeg.selectedSegmentIndex == SEGMENT_TCP_IP {
            self._buttonTappQueue.async {
                self.startLoadingView(true)
                Sample.startLanDiscoveryPrinterSample(1, 10000)
                while !Sample.getPrinterDiscoveryComletion() {
                    RunLoop.current.run(mode: RunLoopMode.defaultRunLoopMode, before:Date(timeIntervalSinceNow: 0.5))
                }
                self.stopLoadingView()
                let foundPrinterList = Sample.getFoundPrinterSample()
                DispatchQueue.main.async {
                    if foundPrinterList.count > 0 {
                        let alertController = UIAlertController(title: "", message: "Select Printer address", preferredStyle: .alert)
                        for foundPrinter in foundPrinterList {
                            let title = (foundPrinter as AnyObject).name + "(" + (foundPrinter as AnyObject).ip + ")"
                            alertController.addAction(
                                UIAlertAction(title: title, style: .default, handler: { (action: UIAlertAction!) in
                                    self._addressTxt.text = (foundPrinter as AnyObject).ip
                                    self.saveDefault(self._addressTxt.text! as AnyObject, self.KEY_IP_ADDRESS)
                                })
                            )
                        }
                        alertController.addAction(
                            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                            })
                        )
                        self.present(alertController, animated: true, completion: nil)
                    } else {
                        let alertController = UIAlertController(title: "", message: "Printer is not found", preferredStyle: .alert)
                        alertController.addAction(
                            UIAlertAction(title: "Close", style: .cancel, handler: {(action: UIAlertAction!) in
                            })
                        )
                        self.present(alertController, animated: true, completion: nil)
                    }
                }
            }
        } else if self._printerTypeSeg.selectedSegmentIndex == SEGMENT_BLUETOOTH || self._printerTypeSeg.selectedSegmentIndex == SEGMENT_USB {
            let printerList = NSMutableArray()
            let accessories = EAAccessoryManager.shared().connectedAccessories
            if accessories.count > 0 {
                for obj: EAAccessory in accessories {
                    if obj.protocolStrings.index(of: SII_EXTERNAL_ACCESSORY_PROTOCOL) != nil {
                        let macAddressOptional = obj.value(forKey: "macAddress") as? String
                        if self._printerTypeSeg.selectedSegmentIndex == SEGMENT_BLUETOOTH && macAddressOptional != nil {
                            printerList.add(obj.name)
                        } else if self._printerTypeSeg.selectedSegmentIndex == SEGMENT_USB && macAddressOptional == nil {
                            printerList.add(obj.name)
                        }
                    }
                }
            }
            if printerList.count > 0 {
                let alertController = UIAlertController(title: "", message: "Select printer device", preferredStyle: .alert)
                for printer in printerList {
                    let printerName = "\(printer)"
                    alertController.addAction(
                        UIAlertAction(title: printerName, style: .default, handler: { (action: UIAlertAction!) in
                            self._addressTxt.text = printerName
                            if self._printerTypeSeg.selectedSegmentIndex == self.SEGMENT_BLUETOOTH {
                                self.saveDefault(self._addressTxt.text! as AnyObject, self.KEY_BLUETOOTH_ADDRESS)
                            } else if self._printerTypeSeg.selectedSegmentIndex == self.SEGMENT_USB {
                                self.saveDefault(self._addressTxt.text! as AnyObject, self.KEY_USB_ADDRESS)
                            }
                        })
                    )
                }
                alertController.addAction(
                    UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                    })
                )
                present(alertController, animated: true, completion: nil)
            } else {
                let alertController = UIAlertController(title: "", message: "Printer is not found", preferredStyle: .alert)
                alertController.addAction(
                    UIAlertAction(title: "Close", style: .cancel, handler: {(action: UIAlertAction!) in
                    })
                )
                present(alertController, animated: true, completion: nil)
            }
        }
    }

    @IBAction func onConnectButtonClicked(_ sender: UIButton) {
        var model: Int32 = -1
        if self._printerModel.text == "DPU-S245" {
            model = SII_PM_PRINTER_MODEL_DPU_S245
        } else if self._printerModel.text == "DPU-S445" {
            model = SII_PM_PRINTER_MODEL_DPU_S445
        } else if self._printerModel.text == "RP-E10" {
            model = SII_PM_PRINTER_MODEL_RP_E10
        } else if self._printerModel.text == "RP-D10" {
            model = SII_PM_PRINTER_MODEL_RP_D10
        } else if self._printerModel.text == "MP-B20" {
            model = SII_PM_PRINTER_MODEL_MP_B20
        } else if self._printerModel.text == "MP-B30" {
            model = SII_PM_PRINTER_MODEL_MP_B30
        } else if self._printerModel.text == "RP-F10" {
            model = SII_PM_PRINTER_MODEL_RP_F10
        } else if self._printerModel.text == "MP-B30L" {
            model = SII_PM_PRINTER_MODEL_MP_B30L
        } else if self._printerModel.text == "SLP720RT" {
            model = SII_PM_PRINTER_MODEL_SLP720RT
        }
        var type: Int32 = -1
        if self._printerTypeSeg.selectedSegmentIndex == SEGMENT_TCP_IP {
            type = SII_PM_PRINTER_PORT_TYPE_TCP
        } else if self._printerTypeSeg.selectedSegmentIndex == SEGMENT_BLUETOOTH {
            type = SII_PM_PRINTER_PORT_TYPE_BLUETOOTH
        } else if self._printerTypeSeg.selectedSegmentIndex == SEGMENT_USB {
            type = SII_PM_PRINTER_PORT_TYPE_USB
        }
        let address = self._addressTxt.text!
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.connectSample(model, address, type)
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onDisconnectButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.disconnectSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())

            DispatchQueue.main.async {
                self._lastStatus.text = ""
                self._barcodeStatus.text = ""
                self._barcodeData.text = ""
            }
        }
    }

    @IBAction func onPrintPageModeSampleButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.printPageModeSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onSendTextButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "sendText", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in textField.placeholder = "text input" })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                let textFields: Array<UITextField>? =  alertController.textFields as Array<UITextField>?
                var text = "\n"
                if textFields != nil {
                    text = alertController.textFields![0].text! + "\n"
                }
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.sendTextSample(text)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSendTextExButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "sendTextEx", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in textField.placeholder = "text input" })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                let textFields: Array<UITextField>? =  alertController.textFields as Array<UITextField>?
                var text = "\n"
                if textFields != nil {
                    text = alertController.textFields![0].text! + "\n"
                }
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.sendTextExSample(text)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onPrintBarcodeButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.printBarcodeSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onPrintPDF417ButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.printPDF417Sample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onPrintQRcodeButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.printQRcodeSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onPrintDataMatrixButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.printDataMatrixSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onPrintMaxiCodeButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.printMaxiCodeSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onPrintGS1DataBarStackedButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.printGS1DataBarStackedSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onPrintGS1DataBarStackedOmnidirectionalButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.printGS1DataBarStackedOmnidirectionalSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onPrintGS1DataBarExpandedStackedButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.printGS1DataBarExpandedStackedSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onPrintAztecCodeButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.printAztecCodeSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onCutPaperButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "cutPaper", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "Feed & Full cut", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.cutPaperSample(Sample.CUTTINGMETHOD_PARTIAL)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Feed & Partial cut", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.cutPaperSample(Sample.CUTTINGMETHOD_PARTIAL)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Full cut", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.cutPaperSample(Sample.CUTTINGMETHOD_FULL_NO_FEED)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Partial cut", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.cutPaperSample(Sample.CUTTINGMETHOD_PARTIAL_NO_FEED)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onFeedPositionButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.feedPositionSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onOpenDrawerButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.openDrawerSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onBuzzerButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.buzzerSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onExternalBuzzerButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.externalBuzzerSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onSendBinaryButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "sendBinary", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in textField.placeholder = "hex value input" })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                let textFields: Array<UITextField>? =  alertController.textFields as Array<UITextField>?
                var text = ""
                if textFields != nil {
                    text = alertController.textFields![0].text!
                }
                let data = self.covertHexStringToBinary(text)
                if data == nil {
                    let resultText = "data is not hex value"
                    self.showResult(resultText)
                } else {
                    self._buttonTappQueue.async {
                        self.startLoadingView(false)
                        _ = Sample.sendBinarySample(data!)
                        self.stopLoadingView()
                        self.showResult(Sample.getResultString())
                    }
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSendDataFileButtonClicked(_ sender: UIButton) {
        let fileList = try? FileManager.default.contentsOfDirectory(atPath: DOCUMENTS_PATH)
        var hitFileNames = [String]()
        for fileName in fileList! {
            hitFileNames.append(fileName)
        }
        if hitFileNames.count > 0 {
            let alertController = UIAlertController(title: "sendDataFile", message: nil, preferredStyle: .alert)
            for hitFileName in hitFileNames {
                alertController.addAction(
                    UIAlertAction(title: hitFileName, style: .default, handler: { (action: UIAlertAction!) in
                        let filePath = self.DOCUMENTS_PATH + "/" + hitFileName
                        self._buttonTappQueue.async {
                            self.startLoadingView(false)
                            _ = Sample.sendDataFileSample(filePath)
                            self.stopLoadingView()
                            self.showResult(Sample.getResultString())
                        }
                   })
                )
            }
            alertController.addAction(
                UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        } else {
            let alertController = UIAlertController(title: "", message: "File is not found", preferredStyle: .alert)
            alertController.addAction(
                UIAlertAction(title: "Close", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        }
    }

    @IBAction func onGetStatusButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.getStatusSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onAbortButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.abortSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onRegisterLogoButtonClicked(_ sender: UIButton) {
        let fileList = try? FileManager.default.contentsOfDirectory(atPath: DOCUMENTS_PATH)
        var hitFileNames = [String]()
        for fileName in fileList! {
            if (fileName as NSString).pathExtension == "bmp"
            || (fileName as NSString).pathExtension == "jpg"
            || (fileName as NSString).pathExtension == "jpeg"
            || (fileName as NSString).pathExtension == "png" {
                hitFileNames.append(fileName)
            }
        }
        if hitFileNames.count > 0 {
            let alertController = UIAlertController(title: "registerLogo", message: nil, preferredStyle: .alert)
            for hitFileName in hitFileNames {
                alertController.addAction(
                    UIAlertAction(title: hitFileName, style: .default, handler: { (action: UIAlertAction!) in
                        let filePath = self.DOCUMENTS_PATH + "/" + hitFileName
                        self._buttonTappQueue.async {
                            self.startLoadingView(false)
                            _ = Sample.registerLogoSample(filePath)
                            self.stopLoadingView()
                            self.showResult(Sample.getResultString())
                        }
                    })
                )
            }
            alertController.addAction(
                UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        } else {
            let alertController = UIAlertController(title: "", message: "File is not found", preferredStyle: .alert)
            alertController.addAction(
                UIAlertAction(title: "Close", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        }
    }

    @IBAction func onPrintLogoButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.printLogoSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onUnregisterLogoButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.unregisterLogoSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onRegisterStyleSheetButtonClicked(_ sender: UIButton) {
        let fileList = try? FileManager.default.contentsOfDirectory(atPath: DOCUMENTS_PATH)
        var hitFileNames = [String]()
        for fileName in fileList! {
            if (fileName as NSString).pathExtension == "css" {
                hitFileNames.append(fileName)
            }
        }
        if hitFileNames.count > 0 {
            let alertController = UIAlertController(title: "registerStyleSheet", message: nil, preferredStyle: .alert)
            for hitFileName in hitFileNames {
                alertController.addAction(
                    UIAlertAction(title: hitFileName, style: .default, handler: { (action: UIAlertAction!) in
                        let filePath = self.DOCUMENTS_PATH + "/" + hitFileName
                        self._buttonTappQueue.async {
                            self.startLoadingView(false)
                            _ = Sample.registerStyleSheetSample(filePath)
                            self.stopLoadingView()
                            self.showResult(Sample.getResultString())
                        }
                    })
                )
            }
            alertController.addAction(
                UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        } else {
            let alertController = UIAlertController(title: "", message: "File is not found", preferredStyle: .alert)
            alertController.addAction(
                UIAlertAction(title: "Close", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        }
    }

    @IBAction func onUnregisterStyleSheetButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.unregisterStyleSheetSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onResetPrinterButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.resetPrinterSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onGetPrinterResponseButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "getPrinterResponse", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "REQUEST", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.getPrinterResponseSample(SII_PM_PRINTER_RESPONSE_REQUEST)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "USER_AREA", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.getPrinterResponseSample(SII_PM_PRINTER_RESPONSE_USER_AREA)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "ARRANGE_USER_AREA", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.getPrinterResponseSample(SII_PM_PRINTER_RESPONSE_ARRANGE_USER_AREA)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "NV_GRAPHICS", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.getPrinterResponseSample(SII_PM_PRINTER_RESPONSE_NV_GRAPHICS)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "KEY_CODE", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.getPrinterResponseSample(SII_PM_PRINTER_RESPONSE_KEY_CODE)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "BATTERY_STATUS", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.getPrinterResponseSample(SII_PM_PRINTER_RESPONSE_BATTERY_STATUS)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onStartDiscoveryPrinterButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "startDiscovery", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "TCP/IP", style: .default, handler: { (action: UIAlertAction!) in
                Sample.startLanDiscoveryPrinterSample(1, 10000)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Bluetooth", style: .default, handler: { (action: UIAlertAction!) in
                Sample.startBluetoothDiscoveryPrinterSample()
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onCancelDiscoveryPrinterButtonClicked(_ sender: UIButton) {
        Sample.cancelDiscoveryPrinterSample()
        self.showResult(Sample.getResultString())
    }

    @IBAction func onGetFoundPrinterButtonClicked(_ sender: UIButton) {
        let foundPrinterList = Sample.getFoundPrinterSample()
        if foundPrinterList.count > 0 {
            let str: NSMutableString = "List of FoundPrinter\n"
            for foundPrinter in foundPrinterList {
                str.append((foundPrinter as AnyObject).name + "(" + (foundPrinter as AnyObject).ip + ")\n")
            }
            self.showResult(String(str))
        } else {
            self.showResult("TCP/IP Printer is not found")
        }
    }

    @IBAction func onControlTransactionButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "controlTransaction", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "START", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.controlTransactionSample(Sample.TRANSACTION_START)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "PRINT", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.controlTransactionSample(Sample.TRANSACTION_PRINT)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "CLEAR", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.controlTransactionSample(Sample.TRANSACTION_CLEAR)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }
    
    @IBAction func onGetVersionButtonOnClicked(_ sender: UIButton) {
        self.startLoadingView(false)
        Sample.getVersionSample()
        self.stopLoadingView()
        self.showResult(Sample.getResultString())
    }

    @IBAction func onSendTimeoutButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "sendTimeout", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "get sendTimeout", style: .default, handler: { (action: UIAlertAction!) in
                let timeout = Sample.get_sendTimeoutSample()
                self.showResult(String(format: "sendTimeout:%ldmsec", timeout))
            })
        )
        alertController.addAction(
            UIAlertAction(title: "set sendTimeout", style: .default, handler: { (action: UIAlertAction!) in
                let alertControllerSub = UIAlertController(title: "set sendTimeout", message: nil, preferredStyle: .alert)
                alertControllerSub.addTextField(configurationHandler: { (textField: UITextField) in
                    textField.placeholder = "timeout value input"
                    textField.keyboardType = .numberPad
                })
                alertControllerSub.addAction(
                    UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                        var text = ""
                        if let temptext = alertControllerSub.textFields![0].text {
                            text = temptext
                        }
                        let intVal: Int32? = Int32(text)
                        if intVal != nil {
                            Sample.set_sendTimeoutSample(intVal!)
                            self.showResult(Sample.getResultString())
                        } else {
                            self.showResult("can not covert to Int")
                        }
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                    })
                )
                self.present(alertControllerSub, animated: true, completion: nil)
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onReceiveTimeoutButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "receiveTimeout", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "get receiveTimeout", style: .default, handler: { (action: UIAlertAction!) in
                let timeout = Sample.get_receiveTimeoutSample()
                self.showResult(String(format: "receiveTimeout:%ldmsec", timeout))
            })
        )
        alertController.addAction(
            UIAlertAction(title: "set receiveTimeout", style: .default, handler: { (action: UIAlertAction!) in
                let alertControllerSub = UIAlertController(title: "set receiveTimeout", message: nil, preferredStyle: .alert)
                alertControllerSub.addTextField(configurationHandler: { (textField: UITextField) in
                    textField.placeholder = "timeout value input"
                    textField.keyboardType = .numberPad
                })
                alertControllerSub.addAction(
                    UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                        var text = ""
                        if let temptext = alertControllerSub.textFields![0].text {
                            text = temptext
                        }
                        let intVal: Int32? = Int32(text)
                        if intVal != nil {
                            Sample.set_receiveTimeoutSample(intVal!)
                            self.showResult(Sample.getResultString())
                        } else {
                            self.showResult("can not covert to Int")
                        }
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                    })
                )
                self.present(alertControllerSub, animated: true, completion: nil)
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onInternationalCharacterButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "internationalCharacter", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "get internationalCharacter", style: .default, handler: { (action: UIAlertAction!) in
                Sample.get_internationalCharacterSample()
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "set internationalCharacter", style: .default, handler: { (action: UIAlertAction!) in
                let alertControllerSub = UIAlertController(title: "set internationalCharacter", message: nil, preferredStyle: .alert)
                alertControllerSub.addAction(
                    UIAlertAction(title: "USA", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_USA)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "FRANCE", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_FRANCE)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "GERMANY", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_GERMANY)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "ENGLAND", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_ENGLAND)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "DENMARK_1", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_DENMARK_1)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "SWEDEN", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_SWEDEN)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "ITALY", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_ITALY)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "SPAIN", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_SPAIN)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "JAPAN", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_JAPAN)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "NORWAY", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_NORWAY)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "DENMARK_2", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_DENMARK_2)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "SPAIN_2", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_SPAIN_2)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "LATIN_AMERICA", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_LATIN_AMERICA)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "ARABIA", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_internationalCharacterSample(SII_PM_COUNTRY_ARABIA)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                    })
                )
                self.present(alertControllerSub, animated: true, completion: nil)
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onCodePageButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "codePage", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "get codePage", style: .default, handler: { (action: UIAlertAction!) in
                Sample.get_codePageSample()
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "set codePage", style: .default, handler: { (action: UIAlertAction!) in
                let alertControllerSub = UIAlertController(title: "set codePage", message: nil, preferredStyle: .alert)
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 437", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_437)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage Katakana", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_KATAKANA)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 850", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_850)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 860", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_860)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 863", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_863)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 865", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_865)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 857", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_857)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 737", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_737)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 1252", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_1252)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 866", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_866)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 852", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_852)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 858", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_858)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 855", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_855)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 864", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_864)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 1250", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_1250)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 1251", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_1251)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 1253", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_1253)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "codePage 1254", style: .default, handler: { (action: UIAlertAction!) in
                        Sample.set_codePageSample(SII_PM_CODE_PAGE_1254)
                        self.showResult(Sample.getResultString())
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                    })
                )
                self.present(alertControllerSub, animated: true, completion: nil)
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onPrinterModelButtonClicked(_ sender: UIButton) {
        Sample.get_printerModelSample()
        self.showResult(Sample.getResultString())
    }

    @IBAction func onPortTypeButtonClicked(_ sender: UIButton) {
        Sample.get_portTypeSample()
        self.showResult(Sample.getResultString())
    }

    @IBAction func onIsConnectButtonClicked(_ sender: UIButton) {
        Sample.get_isConnectSample()
        self.showResult(Sample.getResultString())
    }

    @IBAction func onSocketKeepingTimeButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "socketKeepingTime", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "get socketKeepingTime", style: .default, handler: { (action: UIAlertAction!) in
                let socketKeepingTime = Sample.get_socketKeepingTimeSample()
                self.showResult(String(format: "socketKeepingTime:%ldmsec", socketKeepingTime))
            })
        )
        alertController.addAction(
            UIAlertAction(title: "set socketKeepingTime", style: .default, handler: { (action: UIAlertAction!) in
                let alertControllerSub = UIAlertController(title: "set socketKeepingTime", message: nil, preferredStyle: .alert)
                alertControllerSub.addTextField(configurationHandler: { (textField: UITextField) in
                    textField.placeholder = "time value input"
                    textField.keyboardType = .numberPad
                })
                alertControllerSub.addAction(
                    UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                    var text = ""
                        if let temptext = alertControllerSub.textFields![0].text {
                            text = temptext
                        }
                        let intVal: Int32? = Int32(text)
                        if intVal != nil {
                            Sample.set_socketKeepingTimeSample(intVal!)
                            self.showResult(Sample.getResultString())
                        } else {
                            self.showResult("can not covert to Int")
                        }
                    })
                )
                alertControllerSub.addAction(
                    UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                    })
                )
                self.present(alertControllerSub, animated: true, completion: nil)
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    // MARK: - Display API
    @IBAction func onDefragmentButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.defragmentSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onShowTemplateButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set time", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Time(ms)"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 255000"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= 0 {
                    self._buttonTappQueue.async {
                        self.startLoadingView(false)
                        _ = Sample.showTemplateSample(value)
                        self.stopLoadingView()
                        self.showResult(Sample.getResultString())
                    }
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onShowSlideButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set slide id and time", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Slide ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 91"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Time(ms)"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 255000"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                var value2 = Int32.min
                if let temptext2 = alertController.textFields![1].text {
                    if let intVal2: Int32 = Int32(temptext2) {
                       value2 = intVal2
                    }
                }
                if value >= 0 && value2 >= 0 {
                    self._buttonTappQueue.async {
                        self.startLoadingView(false)
                        _ = Sample.showSlideSample(value, value2)
                        self.stopLoadingView()
                        self.showResult(Sample.getResultString())
                    }
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }


    @IBAction func onEnterStandByButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.enterStandbyModeSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onExecuteMacroButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set macro id and time", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Macro ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 127"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Repeat count"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 255"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                var value2 = Int32.min
                if let temptext2 = alertController.textFields![1].text {
                    if let intVal2: Int32 = Int32(temptext2) {
                       value2 = intVal2
                    }
                }
                if value >= 0 && value2 >= 0 {
                    self._buttonTappQueue.async {
                        self.startLoadingView(false)
                        _ = Sample.executeMacroSample(value, value2)
                        self.stopLoadingView()
                        self.showResult(Sample.getResultString())
                    }
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onTurnOnScreenButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "select isON", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "ON", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.turnOnScreenSample(true)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "OFF", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.turnOnScreenSample(false)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSelectTemplateButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set template id and slide id", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Template ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 127"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Slide ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 91"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                var value2 = Int32.min
                if let temptext2 = alertController.textFields![1].text {
                    if let intVal2: Int32 = Int32(temptext2) {
                       value2 = intVal2
                    }
                }
                if value >= 0 && value2 >= -1 {
                    _ = Sample.selectTemplateSample(value, value2)
                    self.showResult(Sample.getResultString())
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateImageDataButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set map id and image id", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Map ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 63"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Image ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 63"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                var value2 = Int32.min
                if let temptext2 = alertController.textFields![1].text {
                    if let intVal2: Int32 = Int32(temptext2) {
                       value2 = intVal2
                    }
                }
                if value >= 0 && value2 >= 0 {
                    _ = Sample.setTemplateImageDataSample(value, value2)
                    self.showResult(Sample.getResultString())
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSelectTemplateTextObjectButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set map id", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Map ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 63"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= 0 {
                    _ = Sample.selectTemplateTextObjectSample(value)
                    self.showResult(Sample.getResultString())
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateTextAlignmentButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "select alignment", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "LEFT", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextAlignmentSample(Sample.ALIGNMENT_LEFT)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "CENTER", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextAlignmentSample(Sample.ALIGNMENT_CENTER)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "RIGHT", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextAlignmentSample(Sample.ALIGNMENT_RIGHT)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateTextLeftMarginButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set left margine", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Margine"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 479"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= 0 {
                    _ = Sample.setTemplateTextLeftMarginSample(value)
                    self.showResult(Sample.getResultString())
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateTextLineSpacingButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set line spacing", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Spacing"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 255"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= 0 {
                    _ = Sample.setTemplateTextLineSpacingSample(value)
                    self.showResult(Sample.getResultString())
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateTextBoldButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "select bold", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "BOLD", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextBoldSample(Sample.BOLD)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "BOLD CANCEL", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextBoldSample(Sample.BOLD_CANCEL)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateTextUnderlineButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "select underline", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "UNDERLINE", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextUnderlineSample(Sample.UNDERLINE_1)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "UNDERLINE CANCEL", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextUnderlineSample(Sample.UNDERLINE_CANCEL)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateTextSizeButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "select scale\nwidth x height", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "1 x 1", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_1_HORIZONTAL_1)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "2 x 1", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_1_HORIZONTAL_2)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "3 x 1", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_1_HORIZONTAL_3)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "4 x 1", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_1_HORIZONTAL_4)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "1 x 2", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_2_HORIZONTAL_1)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "2 x 2", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_2_HORIZONTAL_2)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "3 x 2", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_2_HORIZONTAL_3)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "4 x 2", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_2_HORIZONTAL_4)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "1 x 3", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_3_HORIZONTAL_1)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "2 x 3", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_3_HORIZONTAL_2)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "3 x 3", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_3_HORIZONTAL_3)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "4 x 3", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_3_HORIZONTAL_4)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "1 x 4", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_4_HORIZONTAL_1)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "2 x 4", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_4_HORIZONTAL_2)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "3 x 4", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_4_HORIZONTAL_3)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "4 x 4", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextSizeSample(Sample.VARTICAL_4_HORIZONTAL_4)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateTextFontButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "select font", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "FONT_A", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextFontSample(Sample.FONT_A)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "FONT_B", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextFontSample(Sample.FONT_B)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateTextRegisteredFontButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "select font", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "STANDARD", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextRegisteredFontSample(Sample.FONT_STANDARD)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "OPTION", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextRegisteredFontSample(Sample.FONT_OPTION)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateTextRightSpacingButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set right spacing", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Spacing"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 255"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= 0 {
                    _ = Sample.setTemplateTextRightSpacingSample(value)
                    self.showResult(Sample.getResultString())
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateTextColorButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "select color", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "black", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextColorSample(0x000000)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "blue", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextColorSample(0x0000ff)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "green", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextColorSample(0x00ff00)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "cyan", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextColorSample(0x00ffff)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "red", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextColorSample(0xff0000)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "magenta", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextColorSample(0xff00ff)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "yellow", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextColorSample(0xffff00)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "white", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.setTemplateTextColorSample(0xffffff)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateTextDataButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set text", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            textField.placeholder = "text"
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
            var text = ""
                if let temptext = alertController.textFields![0].text {
                    text = temptext
                }
                _ = Sample.setTemplateTextDataSample(text)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateBarcodeDataButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set map id and barcode data", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Map ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 7"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Barcode data"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "text"
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                var text = ""
                if let temptext2 = alertController.textFields![1].text {
                    text = temptext2
                }
                if value >= 0 {
                    _ = Sample.setTemplateBarcodeDataSample(value, text)
                    self.showResult(Sample.getResultString())
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSetTemplateQrCodeDataButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set map id and QRcode data", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Map ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 7"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "QRcode data"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "text"
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                var text = ""
                if let temptext2 = alertController.textFields![1].text {
                    text = temptext2
                }
                if value >= 0 {
                    _ = Sample.setTemplateQrCodeDataSample(value, text)
                    self.showResult(Sample.getResultString())
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onRegisterTemplateButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set template id and label", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Template ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 127"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Label"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "text"
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                var text = ""
                if let temptext2 = alertController.textFields![1].text {
                    text = temptext2
                }
                if (value != Int32.min) {
                    self.showRegisterTemplateSelectFileView(value, text)
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    func showRegisterTemplateSelectFileView(_ value: Int32, _ text: String) {
        let fileList = try? FileManager.default.contentsOfDirectory(atPath: DOCUMENTS_PATH)
        var hitFileNames = [String]()
        if let list = fileList {
            for fileName in list {
                if (fileName as NSString).pathExtension == "xml" {
                    hitFileNames.append(fileName)
                }
            }
        }
        if hitFileNames.count > 0 {
            let alertController = UIAlertController(title: "select file", message: nil, preferredStyle: .alert)
            for hitFileName in hitFileNames {
                alertController.addAction(
                    UIAlertAction(title: hitFileName, style: .default, handler: { (action: UIAlertAction!) in
                        let filePath = self.DOCUMENTS_PATH + "/" + hitFileName
                        self._buttonTappQueue.async {
                            self.startLoadingView(false)
                            _ = Sample.registerTemplateSample(value, text, filePath)
                            self.stopLoadingView()
                            self.showResult(Sample.getResultString())
                        }
                    })
                )
            }
            alertController.addAction(
                UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        } else {
            let alertController = UIAlertController(title: "", message: "File is not found", preferredStyle: .alert)
            alertController.addAction(
                UIAlertAction(title: "Close", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        }
    }

    @IBAction func onUnregisterTemplateButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set template id", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Template ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 127"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= 0 {
                    self._buttonTappQueue.async {
                        self.startLoadingView(false)
                        _ = Sample.unregisterTemplateSample(value)
                        self.stopLoadingView()
                        self.showResult(Sample.getResultString())
                    }
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onRegisterImageDataButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set image id and label", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Image ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 63"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Label"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "text"
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                var text = ""
                if let temptext2 = alertController.textFields![1].text {
                    text = temptext2
                }
                if (value != Int32.min) {
                    self.showRegisterImageDataSelectFileView(value, text)
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    func showRegisterImageDataSelectFileView(_ value: Int32, _ text: String) {
        let fileList = try? FileManager.default.contentsOfDirectory(atPath: DOCUMENTS_PATH)
        var hitFileNames = [String]()
        if let list = fileList {
            for fileName in list {
                if (fileName as NSString).pathExtension == "jpg"
                || (fileName as NSString).pathExtension == "jpeg"
                || (fileName as NSString).pathExtension == "png" {
                    hitFileNames.append(fileName)
                }
            }
        }
        if hitFileNames.count > 0 {
            let alertController = UIAlertController(title: "select file", message: nil, preferredStyle: .alert)
            for hitFileName in hitFileNames {
                alertController.addAction(
                    UIAlertAction(title: hitFileName, style: .default, handler: { (action: UIAlertAction!) in
                        let filePath = self.DOCUMENTS_PATH + "/" + hitFileName
                        self._buttonTappQueue.async {
                            self.startLoadingView(false)
                            let timeout = Sample.get_sendTimeoutSample()
                            if timeout < 60000 {
                                Sample.set_sendTimeoutSample(60000)
                            }
                            _ = Sample.registerImageDataSample(value, text, filePath)
                            Sample.set_sendTimeoutSample(timeout)
                            self.stopLoadingView()
                            self.showResult(Sample.getResultString())
                        }
                    })
                )
            }
            alertController.addAction(
                UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        } else {
            let alertController = UIAlertController(title: "", message: "File is not found", preferredStyle: .alert)
            alertController.addAction(
                UIAlertAction(title: "Close", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        }
    }

    @IBAction func onUnregisterImageDataButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set image id", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Image ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 91"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= 0 {
                    self._buttonTappQueue.async {
                        self.startLoadingView(false)
                        _ = Sample.unregisterImageDataSample(value)
                        self.stopLoadingView()
                        self.showResult(Sample.getResultString())
                    }
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onRegisterSlideDataButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set slide id and label", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Slide ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 63"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Label"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "text"
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                var text = ""
                if let temptext2 = alertController.textFields![1].text {
                    text = temptext2
                }
                if (value != Int32.min) {
                    self.showRegisterSlideDataSelectFileView(value, text)
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    func showRegisterSlideDataSelectFileView(_ value: Int32, _ text: String) {
        let fileList = try? FileManager.default.contentsOfDirectory(atPath: DOCUMENTS_PATH)
        var hitFileNames = [String]()
        if let list = fileList {
            for fileName in list {
                if (fileName as NSString).pathExtension == "jpg"
                || (fileName as NSString).pathExtension == "jpeg"
                || (fileName as NSString).pathExtension == "png" {
                    hitFileNames.append(fileName)
                }
            }
        }
        if hitFileNames.count > 0 {
            let alertController = UIAlertController(title: "select file", message: nil, preferredStyle: .alert)
            for hitFileName in hitFileNames {
                alertController.addAction(
                    UIAlertAction(title: hitFileName, style: .default, handler: { (action: UIAlertAction!) in
                        let filePath = self.DOCUMENTS_PATH + "/" + hitFileName
                        self._buttonTappQueue.async {
                            self.startLoadingView(false)
                            let timeout = Sample.get_sendTimeoutSample()
                            if timeout < 60000 {
                                Sample.set_sendTimeoutSample(60000)
                            }
                            _ = Sample.registerSlideDataSample(value, text, filePath)
                            Sample.set_sendTimeoutSample(timeout)
                            self.stopLoadingView()
                            self.showResult(Sample.getResultString())
                        }
                    })
                )
            }
            alertController.addAction(
                UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        } else {
            let alertController = UIAlertController(title: "", message: "File is not found", preferredStyle: .alert)
            alertController.addAction(
                UIAlertAction(title: "Close", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        }
    }

    @IBAction func onUnregisterSlideDataButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set slide id", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Slide ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 91"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= 0 {
                    self._buttonTappQueue.async {
                        self.startLoadingView(false)
                        _ = Sample.unregisterSlideDataSample(value)
                        self.stopLoadingView()
                        self.showResult(Sample.getResultString())
                    }
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onRegisterUserDefinedCharacterButtonClicked(_ sender: UIButton) {
        let fileList = try? FileManager.default.contentsOfDirectory(atPath: DOCUMENTS_PATH)
        var hitFileNames = [String]()
        if let list = fileList {
            for fileName in list {
                if (fileName as NSString).pathExtension == "bin" {
                    hitFileNames.append(fileName)
                }
            }
        }
        if hitFileNames.count > 0 {
            let alertController = UIAlertController(title: "select file", message: nil, preferredStyle: .alert)
            for hitFileName in hitFileNames {
                if (hitFileName as NSString).pathExtension == "bin" {
                    alertController.addAction(
                        UIAlertAction(title: hitFileName, style: .default, handler: { (action: UIAlertAction!) in
                            let filePath = self.DOCUMENTS_PATH + "/" + hitFileName
                            self._buttonTappQueue.async {
                                self.startLoadingView(false)
                                _ = Sample.registerUserDefinedCharacterSample(filePath)
                                self.stopLoadingView()
                                self.showResult(Sample.getResultString())
                            }
                        })
                    )
                }
            }
            alertController.addAction(
                UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        } else {
            let alertController = UIAlertController(title: "", message: "File is not found", preferredStyle: .alert)
            alertController.addAction(
                UIAlertAction(title: "Close", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        }
    }

    @IBAction func onUnregisterUserDefinedCharacterButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.unregisterUserDefinedCharacterSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onRegisterOptionFontButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set start and end and width and height", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Start Code"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "32 to 255"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "End Code"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "32 to 255"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Width"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "1 to 255"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Height"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "1 to 255"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var startCode = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        startCode = intVal
                    }
                }
                var endCode = Int32.min
                if let temptext2 = alertController.textFields![1].text {
                    if let intVal2: Int32 = Int32(temptext2) {
                        endCode = intVal2
                    }
                }
                var width = Int32.min
                if let temptext3 = alertController.textFields![2].text {
                    if let intVal3: Int32 = Int32(temptext3) {
                        width = intVal3
                    }
                }
                var height = Int32.min
                if let temptext4 = alertController.textFields![3].text {
                    if let intVal4: Int32 = Int32(temptext4) {
                        height = intVal4
                    }
                }
                if startCode >= 0 && endCode >= 0 && width >= 0 && height >= 0 {
                    self.showRegisterOptionSelectFileView(startCode, endCode, width, height)
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    func showRegisterOptionSelectFileView(_ startCode: Int32, _ endCode: Int32, _ width: Int32, _ height: Int32) {
        let fileList = try? FileManager.default.contentsOfDirectory(atPath: DOCUMENTS_PATH)
        var hitFileNames = [String]()
        if let list = fileList {
            for fileName in list {
                if (fileName as NSString).pathExtension == "bin" {
                    hitFileNames.append(fileName)
                }
            }
        }
        if hitFileNames.count > 0 {
            let alertController = UIAlertController(title: "select file", message: nil, preferredStyle: .alert)
            for hitFileName in hitFileNames {
                alertController.addAction(
                    UIAlertAction(title: hitFileName, style: .default, handler: { (action: UIAlertAction!) in
                        let filePath = self.DOCUMENTS_PATH + "/" + hitFileName
                        self._buttonTappQueue.async {
                            self.startLoadingView(false)
                            _ = Sample.registerOptionFontSample(startCode, endCode, width, height, filePath)
                            self.stopLoadingView()
                            self.showResult(Sample.getResultString())
                        }
                    })
                )
            }
            alertController.addAction(
                UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        } else {
            let alertController = UIAlertController(title: "", message: "File is not found", preferredStyle: .alert)
            alertController.addAction(
                UIAlertAction(title: "Close", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        }
    }

    @IBAction func onUnregisterOptionFontButtonClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.unregisterOptionFontSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onControlMacroRegistrationButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "select control", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "Start", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.controlMacroRegistrationSample(-1, Sample.MACRO_REGISTRATION_START)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Regist", style: .default, handler: { (action: UIAlertAction!) in
                self.controlMacroRegist()
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Clear", style: .default, handler: { (action: UIAlertAction!) in
                _ = Sample.controlMacroRegistrationSample(-1, Sample.MACRO_REGISTRATION_CLEAR)
                self.showResult(Sample.getResultString())
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    func controlMacroRegist() {
        let alertController = UIAlertController(title: "set macro ID", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Macro ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 127"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= -1 {
                    self._buttonTappQueue.async {
                        self.startLoadingView(false)
                        _ = Sample.controlMacroRegistrationSample(value, Sample.MACRO_REGISTRATION_REGIST)
                        self.stopLoadingView()
                        self.showResult(Sample.getResultString())
                    }
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onGetDisplayResponseButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "getDisplayResponse", message: nil, preferredStyle: .alert)
        alertController.addAction(
            UIAlertAction(title: "REQUEST", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.getDisplayResponseSample(SII_PM_DISPLAY_RESPONSE_REQUEST)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "USER_AREA", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.getDisplayResponseSample(SII_PM_DISPLAY_RESPONSE_USER_AREA)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "TEMPLATE_ID_LIST", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.getDisplayResponseSample(SII_PM_DISPLAY_RESPONSE_TEMPLATE_ID_LIST)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "IMAGE_ID_LIST", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.getDisplayResponseSample(SII_PM_DISPLAY_RESPONSE_IMAGE_ID_LIST)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "SLIDE_ID_LIST", style: .default, handler: { (action: UIAlertAction!) in
                self._buttonTappQueue.async {
                    self.startLoadingView(false)
                    _ = Sample.getDisplayResponseSample(SII_PM_DISPLAY_RESPONSE_SLIDE_ID_LIST)
                    self.stopLoadingView()
                    self.showResult(Sample.getResultString())
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "TEMPLATE_LABEL", style: .default, handler: { (action: UIAlertAction!) in
                self.getDisplayResponseTemplateLabel()
            })
        )
        alertController.addAction(
            UIAlertAction(title: "IMAGE_LABEL", style: .default, handler: { (action: UIAlertAction!) in
                self.getDisplayResponseImageLabel()
            })
        )
        alertController.addAction(
            UIAlertAction(title: "SLIDE_LABEL", style: .default, handler: { (action: UIAlertAction!) in
                self.getDisplayResponseSlideLabel()
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    func getDisplayResponseTemplateLabel() {
        let alertController = UIAlertController(title: "set template ID", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Template ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 127"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= 0 {
                    self._buttonTappQueue.async {
                        self.startLoadingView(false)
                        _ = Sample.getDisplayResponseSample(SII_PM_DISPLAY_RESPONSE_TEMPLATE_LABEL, value)
                        self.stopLoadingView()
                        self.showResult(Sample.getResultString())
                    }
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    func getDisplayResponseImageLabel() {
        let alertController = UIAlertController(title: "set image ID", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Image ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 63"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= 0 {
                    self._buttonTappQueue.async {
                        self.startLoadingView(false)
                        _ = Sample.getDisplayResponseSample(SII_PM_DISPLAY_RESPONSE_IMAGE_LABEL, value)
                        self.stopLoadingView()
                        self.showResult(Sample.getResultString())
                    }
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    func getDisplayResponseSlideLabel() {
        let alertController = UIAlertController(title: "set slide ID", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            let label = UILabel(frame: CGRect(x: 0, y: 0, width: 80, height: 30))
            label.text = "Slide ID"
            label.font = UIFont.systemFont(ofSize: 12.0)
            label.textColor = .darkGray
            textField.leftView = label
            textField.leftViewMode = .always
            textField.placeholder = "0 to 91"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= 0 {
                    self._buttonTappQueue.async {
                        self.startLoadingView(false)
                        _ = Sample.getDisplayResponseSample(SII_PM_DISPLAY_RESPONSE_SLIDE_LABEL, value)
                        self.stopLoadingView()
                        self.showResult(Sample.getResultString())
                    }
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }

    @IBAction func onSelectSmartLabelFileButtonClicked(_ sender: UIButton) {
        let fileList = try? FileManager.default.contentsOfDirectory(atPath: DOCUMENTS_PATH)
        var hitFileNames = [String]()
        for fileName in fileList! {
            if (fileName as NSString).pathExtension == "sl" {
                hitFileNames.append(fileName)
            }
        }
        if hitFileNames.count > 0 {
            let alertController = UIAlertController(title: "selecSmartLabelFile", message: nil, preferredStyle: .alert)
            for hitFileName in hitFileNames {
                alertController.addAction(
                    UIAlertAction(title: hitFileName, style: .default, handler: { (action: UIAlertAction!) in
                        let filePath = self.DOCUMENTS_PATH + "/" + hitFileName
                        _ = Sample.selectSmartLabelFileSample(filePath)
                        self.showResult(Sample.getResultString())
                    })
                )
            }
            alertController.addAction(
                UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        } else {
            let alertController = UIAlertController(title: "", message: "File is not found", preferredStyle: .alert)
            alertController.addAction(
                UIAlertAction(title: "Close", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        }
    }
    
    @IBAction func onReplaceTextDataButtonClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set map id and Text data", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            textField.placeholder = "Map ID"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            textField.placeholder = "Text data"
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                var text = ""
                if let temptext2 = alertController.textFields![1].text {
                    text = temptext2
                }
                if value >= 0 {
                    _ = Sample.replaceSmartLabelTextDataSample(value, text)
                    self.showResult(Sample.getResultString())
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }
    
    @IBAction func onReplaceBarcodeDataButtonOnClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set map id and Barcode data", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            textField.placeholder = "Map ID"
            textField.keyboardType = .numberPad
        })
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            textField.placeholder = "Barcode data"
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                var text = ""
                if let temptext2 = alertController.textFields![1].text {
                    text = temptext2
                }
                if value >= 0 {
                    _ = Sample.replaceSmartLabelBarcodeDataSample(value, text)
                    self.showResult(Sample.getResultString())
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }
    
    @IBAction func onReplaceImageDataButtonOnClicked(_ sender: UIButton) {
        let alertController = UIAlertController(title: "set map id and image file", message: nil, preferredStyle: .alert)
        alertController.addTextField(configurationHandler: { (textField: UITextField) in
            textField.placeholder = "Map ID"
            textField.keyboardType = .numberPad
        })
        alertController.addAction(
            UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in
                var value = Int32.min
                if let temptext = alertController.textFields![0].text {
                    if let intVal: Int32 = Int32(temptext) {
                        value = intVal
                    }
                }
                if value >= 0 {
                    self.showReplaceImageDataSelectFileView(value)
                } else {
                    self.showResult("can not covert to Int")
                }
            })
        )
        alertController.addAction(
            UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
            })
        )
        present(alertController, animated: true, completion: nil)
    }
    
    func showReplaceImageDataSelectFileView(_ value: Int32) {
        let fileList = try? FileManager.default.contentsOfDirectory(atPath: DOCUMENTS_PATH)
        var hitFileNames = [String]()
        if let list = fileList {
            for fileName in list {
                if (fileName as NSString).pathExtension == "jpg"
                || (fileName as NSString).pathExtension == "jpeg"
                || (fileName as NSString).pathExtension == "bmp"
                || (fileName as NSString).pathExtension == "png" {
                    hitFileNames.append(fileName)
                }
            }
        }
        if hitFileNames.count > 0 {
            let alertController = UIAlertController(title: "select file", message: nil, preferredStyle: .alert)
            for hitFileName in hitFileNames {
                alertController.addAction(
                    UIAlertAction(title: hitFileName, style: .default, handler: { (action: UIAlertAction!) in
                        let filePath = self.DOCUMENTS_PATH + "/" + hitFileName
                        let image = self.getUIImageFromFilePath(filePath)
                        _ = Sample.replaceSmartLabelImageDataSample(value, image)
                        self.showResult(Sample.getResultString())
                    })
                )
            }
            alertController.addAction(
                UIAlertAction(title: "Cancel", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        } else {
            let alertController = UIAlertController(title: "", message: "File is not found", preferredStyle: .alert)
            alertController.addAction(
                UIAlertAction(title: "Close", style: .cancel, handler: {(action: UIAlertAction!) in
                })
            )
            present(alertController, animated: true, completion: nil)
        }
    }

    func getUIImageFromFilePath(_ filePath: String) -> UIImage? {
        let fileUrl = URL(fileURLWithPath: filePath)
        do {
            let fileData: Data? = try Data(contentsOf: fileUrl)
            if let unwrapped = fileData {
                let image = UIImage(data: unwrapped)
                return image
            }
        } catch {
        }
        return nil
    }

    @IBAction func onPrintSmartLabelImageDataButtonOnClicked(_ sender: UIButton) {
        self._buttonTappQueue.async {
            self.startLoadingView(false)
            _ = Sample.printSmartLabelImageDataSample()
            self.stopLoadingView()
            self.showResult(Sample.getResultString())
        }
    }

    @IBAction func onEncodeSwitchValueChanged(_ sender: Any) {
        if (sender as AnyObject).isOn {
            self._barcodeEncodeSwicthLabel.text = "String"
        } else {
            self._barcodeEncodeSwicthLabel.text = "Binary"
        }
    }

    // MARK: - Private Methods
    func configureLoadingView() {
        self._loadingViewBackGraund = UIView(frame: view.bounds)
        self._loadingViewBackGraund.backgroundColor = UIColor.gray.withAlphaComponent(0.5)
        self._loadingViewFrame = UIView(frame: view.bounds)
        if #available(iOS 13.0, *) {
            self._loadingViewFrame.backgroundColor = UIColor.systemBackground
        } else {
            self._loadingViewFrame.backgroundColor = UIColor.white
        }
        self._loadingViewFrame.frame = CGRect(x: 0, y: 0, width: 130, height: 130)
        self._loadingViewFrame.layer.cornerRadius = 5.0
        self._loadingViewFrame.center = CGPoint(x: self._loadingViewBackGraund.bounds.midX, y: self._loadingViewBackGraund.bounds.midY)
        self._loadingIndicator = UIActivityIndicatorView(activityIndicatorStyle: .whiteLarge)
        self._loadingIndicator.color = UIColor(red: 19 / 255.0, green: 144 / 255.0, blue: 255 / 255.0, alpha: 1.0)
        self._loadingIndicator.hidesWhenStopped = true
        self._loadingViewCancelButton = UIButton()
        self._loadingViewCancelButton.frame = CGRect(x: 0, y: 0, width: 80, height: 30)
        self._loadingViewCancelButton.layer.borderColor = UIColor(red: 19 / 255.0, green: 144 / 255.0, blue: 255 / 255.0, alpha: 1.0).cgColor
        self._loadingViewCancelButton.layer.position = CGPoint(x: self._loadingViewFrame.bounds.midX, y: 95.0)
        self._loadingViewCancelButton.layer.borderWidth = 1.0
        self._loadingViewCancelButton.layer.cornerRadius = 15.0
        self._loadingViewCancelButton.clipsToBounds = true
        self._loadingViewCancelButton.titleLabel!.font = UIFont.systemFont(ofSize: 12)
        self._loadingViewCancelButton.setTitle("Cancel", for: UIControlState())
        self._loadingViewCancelButton.setTitleColor(UIColor(red: 19 / 255.0, green: 144 / 255.0, blue: 255 / 255.0, alpha: 1.0), for: UIControlState())
        self._loadingViewCancelButton.addTarget(self, action: #selector(self.loadingViewCancelButtonClicked), for: .touchUpInside)
        self._loadingViewFrame.addSubview(self._loadingViewCancelButton)
        self._loadingViewFrame.addSubview(self._loadingIndicator)
        self._loadingViewBackGraund.addSubview(self._loadingViewFrame)
        view.addSubview(self._loadingViewBackGraund)
        self._loadingViewBackGraund.isHidden = true
    }

    @objc func loadingViewCancelButtonClicked() {
        Sample.cancelDiscoveryPrinterSample()
    }

    func startLoadingView(_ cancelButtonEnable: Bool) {
        DispatchQueue.main.async {
            self._loadingViewCancelButton.removeFromSuperview()
            self._loadingViewFrame.layer.position = CGPoint(x: self.view.bounds.midX, y: self.view.bounds.midY)
            if cancelButtonEnable {
                self._loadingViewFrame.addSubview(self._loadingViewCancelButton)
                self._loadingIndicator.layer.position = CGPoint(x: self._loadingViewFrame.bounds.midX, y: 50.0)
            } else {
                self._loadingIndicator.layer.position = CGPoint(x: self._loadingViewFrame.bounds.midX, y: self._loadingViewFrame.bounds.midY)
            }
            self._loadingIndicator.startAnimating()
            self._loadingViewBackGraund.isHidden = false
        }
        RunLoop.current.run(mode: RunLoopMode.defaultRunLoopMode, before:Date(timeIntervalSinceNow: 0.1))
    }

    func stopLoadingView() {
        DispatchQueue.main.async {
            self._loadingIndicator.stopAnimating()
            self._loadingViewBackGraund.isHidden = true
        }
    }

    func showResult(_ resultText: String) {
        DispatchQueue.main.async {
            if resultText.utf8.count > 10 {
                if (resultText as NSString).substring(to: 10) == "Exception:" {
                    let title = "Exception"
                    let message = (resultText as NSString).substring(from: 10)
                    let alertController = UIAlertController(title: title, message: message, preferredStyle: .alert)
                    alertController.addAction(UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in }))
                    self.present(alertController, animated: true, completion: nil)
                } else {
                    let alertController = UIAlertController(title: "", message: resultText, preferredStyle: .alert)
                    alertController.addAction(UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in }))
                    self.present(alertController, animated: true, completion: nil)
                }
            } else if resultText.utf8.count > 0 {
                let alertController = UIAlertController(title: "", message: resultText, preferredStyle: .alert)
                alertController.addAction(UIAlertAction(title: "OK", style: .default, handler: { (action: UIAlertAction!) in }))
                self.present(alertController, animated: true, completion: nil)
            }
        }
    }

    func saveDefault(_ object: AnyObject, _ key: String) {
        let myDefaults = UserDefaults.standard
        myDefaults.set(object, forKey: key)
        myDefaults.synchronize()
    }

    func configureUIButtons() {
        self.configureUIButton(connectButton)
        self.configureUIButton(disConnectButton)
        self.configureUIButton(printPageModeButton)
        self.configureUIButton(sendTextButton)
        self.configureUIButton(sendTextExButton)
        self.configureUIButton(printBarcodeButton)
        self.configureUIButton(printPDF417Button)
        self.configureUIButton(printQRcodeButton)
        self.configureUIButton(printDataMatrixButton)
        self.configureUIButton(printMaxiCodeButton)
        self.configureUIButton(printGS1DataBarStackedButton)
        self.configureUIButton(printGS1DataBarStackedOmnidirectionalButton)
        self.configureUIButton(printGS1DataBarExpandedStackedButton)
        self.configureUIButton(printAztecCodeButton)
        self.configureUIButton(cutPaperButton)
        self.configureUIButton(feedPositionButton)
        self.configureUIButton(openDrawerButton)
        self.configureUIButton(buzzerButton)
        self.configureUIButton(externalBuzzerButton)
        self.configureUIButton(sendBinaryButton)
        self.configureUIButton(sendDataFileButton)
        self.configureUIButton(getStatusButton)
        self.configureUIButton(abortButton)
        self.configureUIButton(registerLogoButton)
        self.configureUIButton(printLogoButton)
        self.configureUIButton(unregisterLogoButton)
        self.configureUIButton(registerStyleSheetButton)
        self.configureUIButton(unregisterStyleSheetButton)
        self.configureUIButton(resetPrinterButton)
        self.configureUIButton(getPrinterResponseButton)
        self.configureUIButton(startDiscoveryPrinterButton)
        self.configureUIButton(cancelDiscoveryPrinterButton)
        self.configureUIButton(getFoundPrinterButton)
        self.configureUIButton(getVersionButton)
        self.configureUIButton(controlTransactionButton)
        self.configureUIButton(sendTimeoutButton)
        self.configureUIButton(receiveTimeoutButton)
        self.configureUIButton(internationalCharacterButton)
        self.configureUIButton(codePageButton)
        self.configureUIButton(printerModelButton)
        self.configureUIButton(portTypeButton)
        self.configureUIButton(isConnectButton)
        self.configureUIButton(socketKeepingTimeButton)
        self.configureUIButton(defragmentButton)
        self.configureUIButton(showTemplateButton)
        self.configureUIButton(showSlideButton)
        self.configureUIButton(enterStandbyModeButton)
        self.configureUIButton(executeMacroButton)
        self.configureUIButton(turnOnScreenButton)
        self.configureUIButton(selectTemplateButton)
        self.configureUIButton(setTemplateImageDataButton)
        self.configureUIButton(selectTemplateTextObjectButton)
        self.configureUIButton(setTemplateTextAlignmentButton)
        self.configureUIButton(setTemplateTextLeftMarginButton)
        self.configureUIButton(setTemplateTextLineSpacingButton)
        self.configureUIButton(setTemplateTextBoldButton)
        self.configureUIButton(setTemplateTextUnderlineButton)
        self.configureUIButton(setTemplateTextSizeButton)
        self.configureUIButton(setTemplateTextFontButton)
        self.configureUIButton(setTemplateTextRegisteredFontButton)
        self.configureUIButton(setTemplateTextRightSpacingButton)
        self.configureUIButton(setTemplateTextColorButton)
        self.configureUIButton(setTemplateTextDataButton)
        self.configureUIButton(setTemplateBarcodeDataButton)
        self.configureUIButton(setTemplateQrCodeDataButton)
        self.configureUIButton(registerTemplateButton)
        self.configureUIButton(unregisterTemplateButton)
        self.configureUIButton(registerImageDataButton)
        self.configureUIButton(unregisterImageDataButton)
        self.configureUIButton(registerSlideDataButton)
        self.configureUIButton(unregisterSlideDataButton)
        self.configureUIButton(registerUserDefinedCharacterButton)
        self.configureUIButton(unregisterUserDefinedCharacterButton)
        self.configureUIButton(registerOptionFontButton)
        self.configureUIButton(unregisterOptionFontButton)
        self.configureUIButton(controlMacroRegistrationButton)
        self.configureUIButton(getDisplayResponseButton)
        self.configureUIButton(selectSmartLabelFileButton)
        self.configureUIButton(replaceTextDataButton)
        self.configureUIButton(replaceBarcodeDataButton)
        self.configureUIButton(replaceImageDataButton)
        self.configureUIButton(printSmartLabelImageDataButton)
    }

    func configureUIButton(_ button: UIButton) {
        button.layer.borderColor = UIColor(red: 19 / 255.0, green: 144 / 255.0, blue: 255 / 255.0, alpha: 1.0).cgColor
        button.layer.borderWidth = 1.0
        button.layer.cornerRadius = 5.0
        button.clipsToBounds = true
        button.titleLabel!.font = UIFont.systemFont(ofSize: 14)
    }

    func configureUITextField() {
        self._barcodeData.layer.borderColor = UIColor.darkGray.cgColor
    }

    func covertHexStringToBinary(_ hexString: String) -> Data? {
        if hexString.utf8.count % 2 > 0 {
            return nil
        }
        var str = hexString.replacingOccurrences(of: "<", with: "")
        str = str.replacingOccurrences(of: ">", with: "")
        str = str.replacingOccurrences(of: " ", with: "")
        if hexString != str {
            return nil
        }
        str = str.uppercased()
        let nsstr = str as NSString
        let chars = nsstr.utf8String
        var i = 0
        let len = nsstr.length
        let data = NSMutableData(capacity: len/2)!
        var byteChars:[CChar] = [0,0]
        var wholeByte :CUnsignedLong
        while i < len {
            if (chars?[i])! < 48 || (57 < (chars?[i])! && (chars?[i])! < 65 ) || 70 < (chars?[i])! {
                return nil
            }
            byteChars[0] = (chars?[i])!
            i+=1
            if (chars?[i])! < 48 || (57 < (chars?[i])! && (chars?[i])! < 65 ) || 70 < (chars?[i])! {
                return nil
            }
            byteChars[1] = (chars?[i])!
            i+=1
            wholeByte = strtoul(byteChars, nil, 16)
            data.append(&wholeByte, length: 1)
        }
        return data as Data
    }

    // MARK: - UITextField delegate
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        textField.resignFirstResponder()
        return true
    }

    // MARK: - printerManeger delegate
    func didStatusChange(_ printerManager: SIIPrinterManager!, status: Int) {
        DispatchQueue.main.async {
            self._lastStatus.text = String(format: "0x%02x", status)
        }
    }

    func didBarcodeScannerReadData(_ printerManager: SIIPrinterManager!, data: Data) {
        DispatchQueue.main.async {
            if self._barcodeEncodeSwitch.isOn {
                let encodedStringOptional: String? = String(data: data, encoding: .shiftJIS)
                if let encodedStringBinded = encodedStringOptional {
                    self._barcodeData.isEditable = true
                    self._barcodeData.text = encodedStringBinded
                    self._barcodeData.isEditable = false
                } else {
                    self._barcodeData.isEditable = true
                    self._barcodeData.text = "Encoding failed!!"
                    self._barcodeData.isEditable = false
                }
            } else {
                let endCount = data.count - 1
                let binaryString = data[0...endCount].map { String(format: "%01X", $0) }.joined()
                self._barcodeData.text = binaryString
            }
        }
    }

    func didBarcodeScannerChangedOnline(_ printerManager: SIIPrinterManager!) {
        DispatchQueue.main.async {
            self._barcodeStatus.text = "Online"
        }
    }

    func didBarcodeScannerChangedOffline(_ printerManager: SIIPrinterManager!) {
        DispatchQueue.main.async {
            self._barcodeStatus.text = "Offline"
        }
    }
}
